//colorspace conversions
function rgb2hsl(){
	var a = arrayfromargs(arguments);
	var r = a[0];
	var g = a[1];
	var b = a[2];

    var max = Math.max(r, g, b), min = Math.min(r, g, b);
    var h, s, l = (max + min) / 2;

    if(max == min){
        h = s = 0; // achromatic
    }else{
        var d = max - min;
        //s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
		s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
		//s = delta === 0 ? 0 : delta / (1 - Math.abs(2 * l - 1));

        switch(max){
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }
        h /= 6;
    }
    //post("rgbC:", [r,g,b], "\n");

	outlet(0,h, s, l);
    //return [h, s, l];
}
