const path = require('path');
const maxAPI = require('max-api');

var options = {
    host: '255.255.255.255'
}
 
var artnet = require('artnet')(options);

// This will be printed directly to the Max console
maxAPI.post(`Loaded the ${path.basename(__filename)} script`);


maxAPI.addHandler("artnet", (...args) => {
	
	artnet.set(args[0], args[1], args[2]);
	
	// The outlet function sends the arguments right back to Max. Hence, echo.
	maxAPI.outlet(...args);
});